<?PHP
class shell2 {
	public $user='';
	public $pass='';
	public $host='';
	public $port='';
	
	var $conn;
	var $error;
	var $stream;

	function __construct($user, $pass, $host, $port)
	{
		$this->user = $user;
		$this->pass = $pass;
		$this->host = $host;
		$this->port = $port;
	}

	function init()
	{
		if ( $this->login($this->user,$this->pass,$this->host,$this->port) )
		{
			if (!($io = @ssh2_shell($this->conn,"vt102")))
			{
				echo "Load screen (vt102) failed.<br />";
				exit(1);
			}
		}
		else
		{
			echo $this->error;
			exit(1);
		}
	}

	function login($user, $pass, $host, $port=22) {
		if ($this->connect($host,$port)) {
			if ($this->auth_pwd($user,$pass)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function connect($host,$port=22) {
		if ($this->conn = ssh2_connect($host, $port)) {
			return true;
		} else {
			$this->error = '[x] Can not connected to '.$host.':'.$port;
			return false;
		}
	}

	function auth_pwd($u,$p) {
		if (ssh2_auth_password($this->conn, $u, $p)) {
			return true;
		} else {
			$this->error = 'Login Failed ' . $u . ' _ ' . $p;
			return false;
		}
	}

	function send_file($localFile,$remoteFile,$permision) {
		if (@ssh2_scp_send($this->conn, $localFile, $remoteFile, $permision)) {
			return true;
		} else {
			$this->error = 'Can not transfer file';
			return false;
		}
	}

	function get_file($remoteFile,$localFile) {
		if (ssh2_scp_recv($this->conn, $remoteFile, $localFile)) {
			return true;
		} else {
			return false;
		}
	}

	function startServer()
	{
		// check if is on
		// if yes - error
		// if no - start screen and serv 'tfs'
		$this->exec_cmd('pgrep screen');
		usleep(500000);
		$out = $this->get_output();
		if(empty($out))
		{
			$this->exec_cmd('screenie -j ots "sh restart.sh"');
			echo 'Server is starting.';
		}
		else
			echo '"tfs" is running on "screen", you cannot open server when there is running server.';
	}

	function restartServer()
	{
		$this->exec_cmd('killall tfs -s SIGKILL -q');
		echo 'Process "tfs" killed. It should restart server, if it was running.';
	}

	function saveAndRestartServer()
	{
		$this->exec_cmd('killall tfs -s SIGQUIT -q');
		echo 'Sent signal "save and shutdown" to "tfs". It should save and restart server.';
	}

	function saveServer()
	{
		$this->exec_cmd('killall tfs -s SIGHUP -q');
		echo 'Sent signal "save" to "tfs". It should save server.';
	}

	function cleanServer()
	{
		$this->exec_cmd('killall tfs -s SIGTRAP -q');
		echo 'Sent signal "clean" to "tfs". It should clean map on server.';
	}

	function forceShutdown()
	{
		$this->exec_cmd('killall -q screen');
		$this->exec_cmd('killall tfs -s SIGKILL -q');
		echo 'Processes "screen" killed. It should kill all "tfs" processes too.';
	}

	function exec_cmd($cmd) {
		$this->stream=ssh2_exec($this->conn, $cmd);
		stream_set_blocking( $this->stream, true );
	}

	function get_output() {
		$line = '';
		while ($get=fgets($this->stream)) {
			$line.=$get;
		}
		return $line;
	}

	function disconnect() {
		// if disconnect function is available call it..
		if ( function_exists('ssh2_disconnect') ) {
			ssh2_disconnect($this->conn);
		} else { // if no disconnect func is available, close conn, unset var
			@fclose($this->conn);
			unset($this->conn);
		}
		// return null always
		return NULL;
	}
}